//---------------------------------------------------------------------------
// MPI_Op_create - a user defined function
//---------------------------------------------------------------------------
#if (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
#elif (defined _WIN32) || (defined _WIN64)
	#include <conio.h>
	#include <direct.h>
#endif

#include<mpi.h>
#include<stdlib.h>
#include<stdio.h>
#include <iostream>
using namespace std;
//---------------------------------------------------------------------------
void my_function(void* invec, void* inoutvec, int* len, MPI_Datatype* datatype)
{
	int* a, * b;
	a = (int*)invec;
	b = (int*)inoutvec;
	for (int i = 0; i < *len; i++)
		b[i] = b[i] + a[i];
}

int main(int argc, char** argv)
{
	int i, rank, size;
	int inputs[5], results2[5];
	MPI_Op op1;

	MPI_Init(&argc, &argv);
	MPI_Comm_size(MPI_COMM_WORLD, &size);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	if (rank == 0) {
		printf("\nThere are %d processors.\n", size);
		fflush(stdout);
	}

	MPI_Op_create(my_function, 1, &op1);

	for (i = 0; i < 5; i++)
		inputs[i] = i;
	for (i = 0; i < 5; i++)
		results2[i] = 0;

	printf("\nProcess %d: values of inputs:\n", rank);
	for (i = 0; i < 5; i++)
		printf("%d ", inputs[i]);
	printf("\n");
	fflush(stdout);

	MPI_Reduce(inputs, results2, 5, MPI_INT, op1, 0, MPI_COMM_WORLD);

	MPI_Op_free(&op1);

	if (rank == 0) {
		printf("\nThe sums of the input values are:\n");
		for (i = 0; i < 5; i++)
			printf("%d ", results2[i]);
		printf("\n");
	}
	MPI_Finalize();
	return 0;
}